<bugID>716174<Summary>nsLocalFile::CopyTo called on the main thread during startup</Summary><Description>A few minutes ago, I started Firefox, and got a pause during startup (while tabs from saved session were being loaded) of 3300 ms. My profiler says that most of that time was spent inside nsLocalFile::CopyTo:

sample 1955098613
    NtWaitForMultipleObjects
    WaitForMultipleObjectsEx
    WaitForMultipleObjects
    GetDurationFormatEx
    CopyFileExW
    CopyFileExW
    CopyFileExW
    nsLocalFile::CopySingleFile
    nsLocalFile::CopyMove
    nsLocalFile::CopyTo
    NS_InvokeByIndex_P
    XPCWrappedNative::CallMethod
    XPC_WN_CallMethod

XPC_WN_CallMethod is as deep as the stack trace gets (it couldn't figure out the rest, apparently), so I really don't know who was calling that. I do know that just before the end of the 3300 ms there was a stack involving sqlite and cookies. Here is the relevant snippet from the middle of that stack:

    sqlite3_exec
    mozilla::storage::Connection::initialize
    mozilla::storage::Service::OpenUnsharedDatabase
    nsCookieService::TryInitDB
    nsCookieService::InitDBStates
    nsCookieService::Init
    nsCookieService::GetSingleton
    nsICookieServiceConstructor
    mozilla::GenericFactory::CreateInstance
    nsComponentManagerImpl::CreateInstance
    nsComponentManagerImpl::GetService
    nsJSCID::GetService
    NS_InvokeByIndex_P
    XPCWrappedNative::CallMethod
    XPC_WN_CallMethod
    js::InvokeKernel
    js::Interpret
    js::RunScript</Description></bugID>